#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <pthread.h>
#include <ctime>

const int arrSize = 10;
int A[arrSize] ;  //общий массив
pthread_rwlock_t rwlock ;  //блокировка чтения-записи

//стартовая функция потоков-читателей
void *funcRead(void *param) {
    int rNum = *((int*)param);
    while (1) {
        //получить случайный индекс
        int number = random() % arrSize;
        //закрыть блокировку для чтения
        pthread_rwlock_rdlock(&rwlock) ;
        //прочитать данные из общего массива – критическая секция
        int a = A[number] ;
        //открыть блокировку
        pthread_rwlock_unlock(&rwlock) ;
        
        unsigned int F = 1 ;  //вычислить факториал
        for (int i = 2 ; i <= a ; i++)	F=F*i ;
        printf("time = %u ---> Читатель %d: Элемент[%d] -> %d! = %u\n", clock(), rNum, number , a, F) ;
        ///sleep(3);
    }
    return nullptr;
}

//стартовая функция потоков-писателей
void *funcWrite(void *param) {
    int wNum = *((int*)param);
    while (1) {
        //получить случайный индекс
        int number = random() % arrSize;
        //закрыть блокировку для записи
        pthread_rwlock_wrlock(&rwlock) ;
        //изменить элемент общего массива – критическая секция
        A[number] = random() % 10 + 1;
        //открыть блокировку
        pthread_rwlock_unlock(&rwlock) ;
        fprintf(stdout,"time = %u ---> Писатель %d: Элемент[%d] = % d\n", clock(), wNum, number, A[number]) ;
        ///sleep(6);
    }
    return nullptr;
}

int main() {
    // Начальная инициализация массива
    for(int i = 0; i < arrSize; i++) {
        A[i] = 1;
    }
    
    //инициализация блокировки чтения-записи
    pthread_rwlock_init(&rwlock, NULL) ;
    
    //создание четырех потоков-читателей
    pthread_t threadR[4] ;
    int readers[4];
    for (int i=0 ; i < 4 ; i++) {
        readers[i] = i+1;
        pthread_create(&threadR[i], NULL, funcRead, (void*)(readers+i)) ;
    }
    
    //создание трех потоков-писателей
    pthread_t threadW[3] ;
    int writers[3];
    for (int i=0 ; i < 3 ; i++) {
        writers[i] = i+1;
        pthread_create(&threadW[i], NULL, funcWrite, (void*)(writers+i)) ;
    }
    
    //пусть главный поток будет потоком-писателем
    int mNum = 0;
    funcWrite((void*)&mNum) ;
    
    return 0;
}
